function keyDown(e) {
    switch(e.keyCode){
        case 38: player.direction = 1; break; // up
        case 40: player.direction = -1; break; // down
        case 37: player.turn = -1; break; //left
        case 39: player.turn = 1; break; // right
    }
}
function keyUp(e) {
    switch(e.keyCode){
        case 38:
        case 40: player.direction = 0; break;
        case 37:
        case 39: player.turn = 0; break;
    }
}
function only360(angle) {
    angle %= Game.twoPi;
    while(angle < 0) {angle += Game.twoPi;}
    return angle;
}
function createGrad(ctx, x0, y0, x1, y1, colour0, colour1, colour2){
    let grad = ctx.createLinearGradient(x0,y0,x1, y1);
    grad.addColorStop(0, colour0);
    if(arguments.length === 8){
        grad.addColorStop(0.5, colour1);
        grad.addColorStop(1, colour2);
    } else {
        grad.addColorStop(1, colour1);
    }
    return grad;
}
function setWalls() {
    Game.walls.push(new Image());
    Game.walls[0].src = "images/stonewall.png";
    Game.walls.push(new Image());
    Game.walls[1].src = "images/stonebars.png";
    Game.walls.push(new Image());
    Game.walls[2].src = "images/stonecell.png";
}
function setLevel(){
    Level.bgTopGrad = createGrad(camera.ctx, 0, 0, 0, Game.projectionHeight/2, "#FF7DE1", "#9B7DE1");
    Level.bgFloorGrad = createGrad(camera.ctx, 0, Game.projectionHeight/2, 0, Game.projectionHeight,  "#101010", "#303030", "#A0A0A0");
    Game.map = new FPSMap("devMap", "mapEntities", Level.grid);
    player.x = player.y = 200;
}
function renderScene() {
    player.animate();
    camera.cast();
}
function initialise() {
    window.addEventListener("keydown", keyDown);
    window.addEventListener("keyup", keyUp);
    Game.playerDistance = (Game.projectionWidth / 2) / Math.tan(Game.fov / 2);
    camera.init("cvView");
    setLevel();
    setWalls();
    Game.timer = setInterval(renderScene, Game.speed);
}
initialise();